/*****************************/
/* PHANTASIE2 ϊvO */
/*****************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXBYTE			65535
#define	MAXPROG			0x3000
#define	S_LEN			128

#define	LETTER_ST		0x04A2
#define	LETTER_ED		0x0681+1

#define	BOXFULL_ST		0x068b
#define	BOXFULL_ED		0x0b9d+1

#define	CHARA_ST		0x0bca
#define	CHARA_ED		0x0f81+1

#define	DISPMAP_ST		0x0f92
#define	DISPMAP_ED		0x1319+1

#define	DISKDRAW_ST		0x1434
#define	DISKDRAW_ED		0x1660+1

#define	BEEP_ST			0x6255-0x6000
#define	BEEP_ED			0x6296-0x6000+1

#define	LETTERUT_ST		0x0495
#define	LETTERUT_ED		0x0674+1

#define	BOXFULLUT_ST	0x067e
#define	BOXFULLUT_ED	0x0b90+1

#define	DISKDRAWUT_ST	0x2a72
#define	DISKDRAWUT_ED	0x2c9e+1

#define	PATCHNUM	9

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;

	typedef struct {
		FILE	*infp;
		char	fname[S_LEN];
		unsigned char	data[MAXPROG];
		int		st;
		int		ed;
		int		mode;
	} patch_t;

	patch_t patch[PATCHNUM];

	unsigned char	buff[MAXBYTE];

	char	fname[S_LEN];

	int		progno;
	int		flen;

	int		c,i,j,k;
	int		stadd,ptno;

	if (argc != 2) {
		fprintf(stderr, "Usage: convp6ph2 program-no. \n");
		exit(1);
	}

	progno = atoi(argv[1]);

	if (progno < 0 || progno > 9) {
		printf("Program number error\n");
		exit(1);
	}

/* parameter set */

	patch[0].st = BOXFULL_ST;
	patch[0].ed = BOXFULL_ED;
	strcpy(patch[0].fname,"boxfull_p6.bin");
	patch[0].mode = 0;

	patch[1].st = CHARA_ST;
	patch[1].ed = CHARA_ED;
	strcpy(patch[1].fname,"dispchara_p6.bin");
	patch[1].mode = 0;

	patch[2].st = LETTER_ST;
	patch[2].ed = LETTER_ED;
	strcpy(patch[2].fname,"displetter_p6.bin");
	patch[2].mode = 0;

	patch[3].st = DISPMAP_ST;
	patch[3].ed = DISPMAP_ED;
	strcpy(patch[3].fname,"dispmap_p6.bin");
	patch[3].mode = 0;

	patch[4].st = DISKDRAW_ST;
	patch[4].ed = DISKDRAW_ED;
	strcpy(patch[4].fname,"diskdraw_p6.bin");
	patch[4].mode = 0;

	patch[5].st = BEEP_ST;
	patch[5].ed = BEEP_ED;
	strcpy(patch[5].fname,"beep_p6.bin");
	patch[5].mode = 1;

	patch[6].st = LETTERUT_ST;
	patch[6].ed = LETTERUT_ED;
	strcpy(patch[6].fname,"displetterut_p6.bin");
	patch[6].mode = 2;

	patch[7].st = BOXFULLUT_ST;
	patch[7].ed = BOXFULLUT_ED;
	strcpy(patch[7].fname,"boxfullut_p6.bin");
	patch[7].mode = 2;

	patch[8].st = DISKDRAWUT_ST;
	patch[8].ed = DISKDRAWUT_ED;
	strcpy(patch[8].fname,"diskdrawut_p6.bin");
	patch[8].mode = 2;


/* open files */

	sprintf(fname,"prog%d.bin",progno);
	if ((infp = fopen(fname, "rb")) == NULL) {
		perror(fname);
		exit(1);
	}

	sprintf(fname,"prog%d_p6.bin",progno);
	if ((outfp = fopen(fname, "wb")) == NULL) {
		perror(fname);
		exit(1);
	}

	for (i = 0;i < PATCHNUM;i ++) {
		if ((patch[i].infp = fopen(patch[i].fname, "rb")) == NULL) {
			perror(patch[i].fname);
			exit(1);
		}
	}


/* t@Cǂݏo */
	i = 0x100;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	flen = i;


	for (i = 0;i < PATCHNUM;i ++) {
		k = patch[i].st;
		while ( (c = fgetc(patch[i].infp)) != EOF) {
			patch[i].data[k] = c;
			k ++;
		}
		if (k != patch[i].ed) {
			printf("%s length error\n",patch[i].fname);
			exit(1);
		}
	}

/********************************/
/********** ʂ̕ϊ **********/
/********************************/
/* FILE READ/WRITE */
	buff[0x0400] = buff[0x0100];
	buff[0x0401] = buff[0x0101];
	buff[0x0402] = buff[0x0102];
	for (i = 0x0100;i < 0x03ff;i ++) {
		buff[i] = 0xff;
	}

	for (i = 0;i < PATCHNUM;i ++) {
		if (patch[i].mode == 0) {
			if (progno == 6 && i == 4) {
				;
			} else if (progno != 9) {
				for (k = patch[i].st;k < patch[i].ed;k ++) {
					buff[k] = patch[i].data[k];
				}
			}
		} else if (patch[i].mode == 2) {
			if (progno == 9) {
				for (k = patch[i].st;k < patch[i].ed;k ++) {
					buff[k] = patch[i].data[k];
				}
			}
		}
	}

	if (progno == 6) {
		buff[0x14ed] = 0xc3; /* L[ */
		buff[0x14ee] = 0xa0; /* L[ */
		buff[0x14ef] = 0x00; /* L[ */
		buff[0x21b4] = 0xf3; /* di  */
		buff[0x21b5] = 0x00; /* nop */
		buff[0x21b9] = 0xfb; /* ei  */
	} else if (progno == 9) {
		buff[0x14e0] = 0xc3; /* L[ */
		buff[0x14e1] = 0xa0; /* L[ */
		buff[0x14e2] = 0x00; /* L[ */
		buff[0x49d5] = 0xf3; /* di  */
		buff[0x49d6] = 0x00; /* nop */
		buff[0x49da] = 0xfb; /* ei  */
	} else {
		buff[0x1781] = 0xc3; /* L[ */
		buff[0x1782] = 0xa0; /* L[ */
		buff[0x1783] = 0x00; /* L[ */
		buff[0x2448] = 0xf3; /* di  */
		buff[0x2449] = 0x00; /* nop */
		buff[0x244d] = 0xfb; /* ei  */
	}


/********************************/
/********** ʂ̕ϊ **********/
/********************************/

	switch (progno) {
		case 0:	/* vO#0iQ[Nj */
				/* 04:00:01:01 */

//			buff[0x39be] = 0x05; /* ^CO ftHgl */
			buff[0x2bfc] = 0x00; /* ^COύX  */
			buff[0x2bfd] = 0x04; /* ^COύX  */

			break;

		case 1:	/* vO#1iTOWNj */
				/* 1C:00:01:01 */

			buff[0x53bb] = 0x00; /* ^COύX  */
			buff[0x53bc] = 0x04; /* ^COύX  */

			break;

		case 2:	/* vO#2itB[hj */
				/* 05:01:0B:01 */

			stadd = 0x6255; ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x2cdd] = 0x00; /* _ŒlύX */
			buff[0x2cde] = 0x0c; /* _ŒlύX */

			buff[0x3967] = 0xa2; /* h  */
			buff[0x3968] = 0x04; /* h  */

			buff[0x3e79] = 0x00; /* ^COύX  */
			buff[0x3e7a] = 0x08; /* ^COύX  */

			buff[0x2e84+0] = 0xc3; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2e84+1] = 0xb0; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2e84+2] = 0x04; /* pbgR=0x00ApbgT=0x05 */

			buff[0x2e8c+0] = 0xc3; /* pbgR=0x05ApbgT=0x00 */
			buff[0x2e8c+1] = 0xc0; /* pbgR=0x05ApbgT=0x00 */
			buff[0x2e8c+2] = 0x04; /* pbgR=0x05ApbgT=0x00 */

			buff[0x2e94+0] = 0xc3; /* pbgR=0x03ApbgT=0x05 */
			buff[0x2e94+1] = 0xd0; /* pbgR=0x03ApbgT=0x05 */
			buff[0x2e94+2] = 0x04; /* pbgR=0x03ApbgT=0x05 */

			break;

		case 3:	/* vO#3i_Wj */
				/* 1A:00:01:01 */

			stadd = 0x5321; ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x2a22] = 0x00; /* _ŒlύX */
			buff[0x2a23] = 0x0c; /* _ŒlύX */

			buff[0x57fe] = 0x00; /* ^COύX  */
			buff[0x57ff] = 0x08; /* ^COύX  */

			buff[0x2575+0] = 0xc3; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2575+1] = 0xb0; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2575+2] = 0x04; /* pbgR=0x00ApbgT=0x05 */

			break;

		case 4:	/* vO#4iGUILDj */
				/* 1D:01:0A:01 */

			buff[0x4aba] = 0x00; /* ^COύX  */
			buff[0x4abb] = 0x04; /* ^COύX  */

			break;

		case 5:	/* vO#5iARMORYj */
				/* 24:00:0B:01 */

			buff[0x3109] = 0x00; /* ^COύX  */
			buff[0x310a] = 0x04; /* ^COύX  */

			break;

		case 6:	/* vO#6iX^[j */
				/* 0C:00:0B:01 */

			stadd = 0x6348; ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x66b6] = 0x00; /* ^COύX  */
			buff[0x66b7] = 0x04; /* ^COύX  */

			buff[0x6e3f+0] = 0xc3; /* pbgR=0x00ApbgT=0x05 */
			buff[0x6e3f+1] = 0xb0; /* pbgR=0x00ApbgT=0x05 */
			buff[0x6e3f+2] = 0x04; /* pbgR=0x00ApbgT=0x05 */

			buff[0x6e47+0] = 0xc3; /* pbgR=0x03ApbgT=0x05 */
			buff[0x6e47+1] = 0xd0; /* pbgR=0x03ApbgT=0x05 */
			buff[0x6e47+2] = 0x04; /* pbgR=0x03ApbgT=0x05 */

			break;

		case 7:	/* vO#7iCOMMANDj */
				/* 09:00:09:01 */

			buff[0x4032] = 0x00; /* ^COύX  */
			buff[0x4033] = 0x04; /* ^COύX  */

			buff[0x2924+0] = 0xc3; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2924+1] = 0xb0; /* pbgR=0x00ApbgT=0x05 */
			buff[0x2924+2] = 0x04; /* pbgR=0x00ApbgT=0x05 */

			break;

		case 8:	/* vO#8iGAME OVERj */
				/* 21:00:07:01 */

			stadd = 0x4982; ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x4355] = 0x00; /* bug fix */
			buff[0x44db] = 0x00; /* bug fix */

			buff[0x4cf0] = 0x00; /* ^COύX  */
			buff[0x4cf1] = 0x04; /* ^COύX  */

			buff[0x5479+0] = 0xc3; /* pbgR=0x00ApbgT=0x05 */
			buff[0x5479+1] = 0xb0; /* pbgR=0x00ApbgT=0x05 */
			buff[0x5479+2] = 0x04; /* pbgR=0x00ApbgT=0x05 */

			buff[0x5481+0] = 0xc3; /* pbgR=0x03ApbgT=0x05 */
			buff[0x5481+1] = 0xd0; /* pbgR=0x03ApbgT=0x05 */
			buff[0x5481+2] = 0x04; /* pbgR=0x03ApbgT=0x05 */

			break;

		case 9:	/* [eBeB */
				/* 04:00:01:01 */

			buff[0x406a] = 0xc0; /* v^BUSY */
			buff[0x406c] = 0x02; /* v^BUSY(bit1) */
			buff[0x406d] = 0xca; /* v^BUSYoiJP NZ  JP Zj */

			buff[0x4071] = 0xf2; /* 0x0D̔] */
			buff[0x4073] = 0x91; /* v^f[^o */
			buff[0x4076] = 0x93; /* v^Xg[uo */
			buff[0x407a] = 0x93; /* v^Xg[uo */

			buff[0x407c] = 0xc0; /* v^BUSY */
			buff[0x407e] = 0x02; /* v^BUSY(bit1) */
			buff[0x407f] = 0xca; /* v^BUSYoiJP NZ  JP Zj */

			buff[0x4083] = 0xf5; /* 0x0A̔] */
			buff[0x4085] = 0x91; /* v^f[^o */
			buff[0x4088] = 0x93; /* v^Xg[uo */
			buff[0x408c] = 0x93; /* v^Xg[uo */

			buff[0x5423] = 0xc0; /* v^BUSY */
			buff[0x5425] = 0x02; /* v^BUSY(bit1) */
			buff[0x5426] = 0xca; /* v^BUSYoiJP NZ  JP Zj */

			buff[0x5431] = 0x2f; /* v^f[^o͂𔽓] */
			buff[0x5432] = 0xd3; /* v^f[^o */
			buff[0x5433] = 0x91; /* v^f[^o */
			buff[0x5434] = 0xaf; /* A=0x00 */
			buff[0x5435] = 0xd3; /* v^Xg[uo */
			buff[0x5436] = 0x93; /* v^Xg[uo */
			buff[0x5437] = 0x3c; /* A=0x01 */
			buff[0x5438] = 0xd3; /* v^Xg[uo */
			buff[0x5439] = 0x93; /* v^Xg[uo */

			break;

		default:
			break;
	}



/* t@C */
	for (i = 0x100;i < flen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(outfp);
	fclose(infp);


	return(0);
}
